
           #include <P12F683.INC>
            LIST        p=12F683    
            __CONFIG    H'30C4'        
                                     
           
Sec           equ         0020h  
Sec0          equ         0021h    
Sec1          equ         0022h
reg           equ         0023h
var           equ         0024h
desiat        equ         0025h
sotni         equ         0026h
edin          equ         0027h
perem         equ         0028h
scetbit       equ         0029h


#DEFINE     clk   	GPIO,1
#DEFINE     dat   	GPIO,4
#DEFINE     cs  	GPIO,5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 

Start         bsf         STATUS,RP0
              movlw       b'01100001'     ;    
              movwf       OSCCON          ; 4 ,   
              bcf         STATUS,RP0      ;
                                          ;
              movlw       b'00100000'     ;    
              movwf       GPIO            ;
                                          ;
              movlw       0x07            ; 
              movwf       CMCON0          ;
                                          ;
              bsf         STATUS,RP0      ;
              movlw       b'11001001'     ;  GP2     ,  
              movwf       TRISIO          ;   
              movlw       b'01010001'     ;     
              movwf       ANSEL           ;Tad = 4 (Fosc/16),  
              bcf         STATUS,RP0      ;GP0(AN0)     , 
                                          ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  
                          
              movlw       b'00000000'     ;    ,  
              movwf       ADCON0          ;     Vdd,
                                          ;   AN0, 
                                          ; ,   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              bsf         STATUS,RP0      ;
              movlw       .255            ;  255     
              movwf       PR2             ; 
              bcf         STATUS,RP0      ;
                                          ;
              movlw       .0              ;      
              movwf       CCPR1L          ;, CCPR1L  CCP1CON(5:4)
              bcf         CCP1CON,4       ; 
              bcf         CCP1CON,5       ;
                                          ;
              movlw       b'00000110'     ;  TMR2 (1:16) 
              movwf       T2CON           ;  TMR2
                                          ;
              movlw       b'00001100'     ; CCP1      
              movwf       CCP1CON         ;      (5:4)
                                          ;    


osnova       bcf         cs          ; 3-    
             movlw       .0
             call        send
             movlw       .0
             call        send
             movlw       .0
             call        send
             bsf         cs
             nop
             nop
             bcf         cs          ; 
             movlw       .1
             call        send
             bsf         cs


              bsf         ADCON0,ADON
begin         bsf         ADCON0,GO_DONE
prov          btfsc       ADCON0,GO_DONE
              goto        prov 
              movf        ADRESH,W
              movwf       CCPR1L
              movwf       var
              call        vivod
              call        pause
              goto        begin
            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vivod       clrf        sotni
pr0         incf        sotni,F ; 
            movlw       .100
            subwf       var,F
            btfsc       STATUS,C
            goto        pr0
            decf        sotni,F
            movlw       .100
            addwf       var,F
            clrf        desiat
pr1         incf        desiat,F ; 
            movlw       .10
            subwf       var,F
            btfsc       STATUS,C
            goto        pr1
            decf        desiat,F
            movlw       .10
            addwf       var,F
            clrf        edin
pr2         incf        edin,F ; 
            movlw       .1
            subwf       var,F
            btfsc       STATUS,C
            goto        pr2
            decf        edin,F

            
            
            clrf       reg

dalee        swapf       sotni,F
             movlw       .4
             movwf       var
             bcf         STATUS,C
a5           rlf         sotni,F
             rlf         reg,F
             decfsz      var,F
             goto        a5

             swapf       edin,F
             movlw       .4
             movwf       var
             bcf         STATUS,C
a6           rlf         edin,F
             rlf         desiat,F
             decfsz      var,F
             goto        a6
 
             bcf         cs          ; 3-    
             movlw       .0
             call        send
             movf        reg,W
             call        send
             movf        desiat,W
             call        send
             bsf         cs
             
             return



send         movwf      perem
             movlw      .8
             movwf      scetbit
povtor       bcf        clk
             btfsc      perem,7
             bsf        dat 
             btfss      perem,7
             bcf        dat 
             bsf        clk
             rlf        perem,F
             decfsz     scetbit,F
             goto       povtor
             bcf        clk
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 100 

pause         movlw       .130            ;
              movwf       Sec1            ;
p2            movlw       .255            ;
              movwf       Sec             ;
p1            decfsz      Sec,F           ;
              goto        p1              ; 
              decfsz      Sec1,F          ; 
              goto        p2              ;
              return                      ;
                                          ;   

              END

